
{***************************************************************************}
{                                                                           }
{     Form: 'BackPropEvalDiagForm.dfm'                                      }
{     Unit: 'BackPropEvalDiagFormFile.pas'                                  }
{     ( containing visualization of learn data in diagrams )                }
{                                                                           }
{     - belonging to:                                                       }
{       Form:    'BackPropForm.dfm'                                         }
{       Unit:    'BackPropFormFile.pas'                                     }
{       Project: 'BackPropagation.dpr'                                      }
{       DLL:     'BackPropagation.dll'                                      }
{       Program: 'ResNeuronum.exe'                                          }
{       ( simulating Neural Networks )                                      }
{                                                                           }
{     - written in Borland Delphi 2.0                                       }
{                                                                           }
{     Copyright (c) 1996-97 TU Ilmenau/ Germany                             }
{                                                                           }
{     Written by:                                                           }
{       Christian Heller                                                    }
{       Grenzgraben 04                                                      }
{       D-98714 Sttzerbach                                                 }
{       Thringen                                                           }
{       Deutschland/ Germany/ Allemagne                                     }
{       Tel.:   +49/ (0)36784/ 50471 (Euro-ISDN)                            }
{       or Tel: +49/ (0)36784/ 50690                                        }
{       Fax G3: +49/ (0)36784/ 50992 (Euro-ISDN)                            }
{       e-mail: Christian.Heller@rz.tu-ilmenau.de                           }
{       www:    http://www.rz.tu-ilmenau.de/~ai008/christian/enmain.htm     }
{       www:    http://www.rz.tu-ilmenau.de/~ai008/resneuronum/enmain.htm   }
{                                                                           }
{     ( all variables & methods in alphabetical order                       }
{     or as appearing in the unit header, respectively )                    }
{                                                                           }
{***************************************************************************}

unit BackPropEvalDiagFormFile;

interface

uses
  { Net component created especially for the project }
  BackPropNet,
  Classes,
  Controls,
  Dialogs,
  ExtCtrls,
  Forms,
  Graphics,
  Messages,
  SysUtils,
  Windows;

type
  TBackPropEvalDiagForm = class(TForm)
    EvalDiagPaintBox1: TPaintBox;
    EvalDiagPaintBox2: TPaintBox;
    EvalDiagPaintBox3: TPaintBox;
    EvalDiagPaintBox4: TPaintBox;
    EvalDiagPanel1: TPanel;
    EvalDiagPanel2: TPanel;
    EvalDiagPanel3: TPanel;
    EvalDiagPanel4: TPanel;
    EvalDiagPanelCurves: TPanel;
    procedure EvalDiagPaintBox1Paint(Sender: TObject);
    procedure EvalDiagPaintBox2Paint(Sender: TObject);
    procedure EvalDiagPaintBox3Paint(Sender: TObject);
    procedure EvalDiagPaintBox4Paint(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  { Private-Deklarationen }
  private
    { Parameters for diagram 1 }
    EvalDiagFactXDiag1: Double;
    EvalDiagFactYDiag1: Double;
    EvalDiagMaxX1: Word;
    EvalDiagMinX1: Word;
    EvalDiagMaxY1: Double;
    EvalDiagMinY1: Double;
    { Parameters for diagram 2 }
    EvalDiagFactXDiag2: Double;
    EvalDiagFactYDiag2: Double;
    EvalDiagMaxX2: Word;
    EvalDiagMinX2: Word;
    EvalDiagMaxY2: Double;
    EvalDiagMinY2: Double;
    { Parameters for diagram 3 }
    EvalDiagFactXDiag3: Double;
    EvalDiagFactYDiag3: Double;
    EvalDiagMaxX3: Word;
    EvalDiagMinX3: Word;
    EvalDiagMaxY3: Double;
    EvalDiagMinY3: Double;
    { Parameters for diagram 4 }
    EvalDiagFactXDiag4: Double;
    EvalDiagFactYDiag4: Double;
    EvalDiagMaxX4: Word;
    EvalDiagMinX4: Word;
    EvalDiagMaxY4: Double;
    EvalDiagMinY4: Double;
  { Public-Deklarationen }
  public
    { Parameters for diagrams }
    EvalDiagDataList1: TRealArray;
    EvalDiagDataList2: TRealArray;
    EvalDiagDataList3: TRealArray;
    EvalDiagDataList4: TRealArray;
    { Help procedure to hand over data for diagram }
    procedure EvalDiagSetDataList1(AnEvalDataList: TRealArray);
    procedure EvalDiagSetDataList2(AnEvalDataList: TRealArray);
    procedure EvalDiagSetDataList3(AnEvalDataList: TRealArray);
    procedure EvalDiagSetDataList4(AnEvalDataList: TRealArray);
  end;

var
  BackPropEvalDiagForm: TBackPropEvalDiagForm;

implementation

{$R *.DFM}

procedure TBackPropEvalDiagForm.EvalDiagPaintBox1Paint(Sender: TObject);
var
  i: Integer;
  HelpString: string;
begin
  Invalidate;
  with EvalDiagPaintBox1.Canvas do begin
    { Background }
    Brush.Color := clWhite;
    FillRect(Rect(0, 0, EvalDiagPaintBox1.Width, EvalDiagPaintBox1.Height));
    { X-axis and arrow }
    Pen.Width := 1;
    Pen.Style := psSolid;
    Pen.Color := clBlack;
    MoveTo(5, (EvalDiagPaintBox1.Height - 30));
    LineTo((EvalDiagPaintBox1.Width - 10), (EvalDiagPaintBox1.Height - 30));
    MoveTo((EvalDiagPaintBox1.Width - 10), (EvalDiagPaintBox1.Height - 30));
    LineTo((EvalDiagPaintBox1.Width - 20), (EvalDiagPaintBox1.Height - 33));
    MoveTo((EvalDiagPaintBox1.Width - 10), (EvalDiagPaintBox1.Height - 30));
    LineTo((EvalDiagPaintBox1.Width - 20), (EvalDiagPaintBox1.Height - 27));
    { Y-axis and arrow }
    MoveTo(10, (EvalDiagPaintBox1.Height - 25)); LineTo(10, 30);
    MoveTo(10, 30); LineTo(7, 40);
    MoveTo(10, 30); LineTo(13, 40);
    { Grid }
    Pen.Style := psDot;
    for i := 1 to 10 do begin
      MoveTo(10 + (i * Round((EvalDiagPaintBox1.Width - 20) / 10)),
      (EvalDiagPaintBox1.Height - 30));
      LineTo(10 + (i * Round((EvalDiagPaintBox1.Width - 20) / 10)), 30);
    end;
    { Display values }
    TextOut((EvalDiagPaintBox1.Width - 150),
    (EvalDiagPaintBox1.Height - 25), 'Lernschritte: ' +
    IntToStr(Round(EvalDiagMaxX1)));
    if (EvalDiagMinY1 > 10)
    then Str(EvalDiagMinY1 : 10 : 2, HelpString)
    else Str(EvalDiagMinY1 : 1 : 8, HelpString);
    TextOut(5, (EvalDiagPaintBox1.Height - 25), 'Minimum: ' + HelpString);
    if (EvalDiagMaxY1 > 10)
    then Str(EvalDiagMaxY1 : 10 : 2, HelpString)
    else Str(EvalDiagMaxY1 : 1 : 8, HelpString);
    TextOut(5, 5, 'Maximum: ' + HelpString);
    { Draw data }
    if (EvalDiagDataList1 <> nil) then begin
      if (EvalDiagDataList1.Count > 0) then begin
        Pen.Style := psSolid;
        Pen.Color := clRed;
        MoveTo(10, ((EvalDiagPaintBox1.Height - 30) -
        Round((EvalDiagDataList1[0] - EvalDiagMinY1) * EvalDiagFactYDiag1)));
        if EvalDiagDataList1.Count > 1 then begin
          for i := 1 to (EvalDiagDataList1.Count - 1) do begin
            LineTo((10 + Round(i * EvalDiagFactXDiag1)),
            ((EvalDiagPaintBox1.Height - 30) -
            Round((EvalDiagDataList1[i] - EvalDiagMinY1) *
            EvalDiagFactYDiag1)));
          end;
        end;
      end;
    end;
  end;
end;

procedure TBackPropEvalDiagForm.EvalDiagPaintBox2Paint(Sender: TObject);
var
  i: Integer;
  HelpString: string;
begin
  Invalidate;
  with EvalDiagPaintBox2.Canvas do begin
    { Background }
    Brush.Color := clWhite;
    FillRect(Rect(0, 0, EvalDiagPaintBox2.Width, EvalDiagPaintBox2.Height));
    { X-axis and arrow }
    Pen.Width := 1;
    Pen.Style := psSolid;
    Pen.Color := clBlack;
    MoveTo(5, (EvalDiagPaintBox2.Height - 30));
    LineTo((EvalDiagPaintBox2.Width - 10), (EvalDiagPaintBox2.Height - 30));
    MoveTo((EvalDiagPaintBox2.Width - 10), (EvalDiagPaintBox2.Height - 30));
    LineTo((EvalDiagPaintBox2.Width - 20), (EvalDiagPaintBox2.Height - 33));
    MoveTo((EvalDiagPaintBox2.Width - 10), (EvalDiagPaintBox2.Height - 30));
    LineTo((EvalDiagPaintBox2.Width - 20), (EvalDiagPaintBox2.Height - 27));
    { Y-axis and arrow }
    MoveTo(10, (EvalDiagPaintBox2.Height - 25)); LineTo(10, 30);
    MoveTo(10, 30); LineTo(7, 40);
    MoveTo(10, 30); LineTo(13, 40);
    { Grid }
    Pen.Style := psDot;
    for i := 1 to 10 do begin
      MoveTo(10 + (i * Round((EvalDiagPaintBox2.Width - 20) / 10)),
      (EvalDiagPaintBox2.Height - 30));
      LineTo(10 + (i * Round((EvalDiagPaintBox2.Width - 20) / 10)), 30);
    end;
    { Display values }
    TextOut((EvalDiagPaintBox2.Width - 150),
    (EvalDiagPaintBox2.Height - 25), 'Lernschritte: ' +
    IntToStr(Round(EvalDiagMaxX2)));
    if (EvalDiagMinY2 > 10)
    then Str(EvalDiagMinY2 : 10 : 2, HelpString)
    else Str(EvalDiagMinY2 : 1 : 8, HelpString);
    TextOut(5, (EvalDiagPaintBox2.Height - 25), 'Minimum: ' + HelpString);
    if (EvalDiagMaxY2 > 10)
    then Str(EvalDiagMaxY2 : 10 : 2, HelpString)
    else Str(EvalDiagMaxY2 : 1 : 8, HelpString);
    TextOut(5, 5, 'Maximum: ' + HelpString);
    { Draw data }
    if (EvalDiagDataList2 <> nil) then begin
      if (EvalDiagDataList2.Count > 0) then begin
        Pen.Style := psSolid;
        Pen.Color := clRed;
        MoveTo(10, ((EvalDiagPaintBox2.Height - 30) -
        Round((EvalDiagDataList2[0] - EvalDiagMinY2) * EvalDiagFactYDiag2)));
        if EvalDiagDataList2.Count > 1 then begin
          for i := 1 to (EvalDiagDataList2.Count - 1) do begin
            LineTo((10 + Round(i * EvalDiagFactXDiag2)),
            ((EvalDiagPaintBox2.Height - 30) -
            Round((EvalDiagDataList2[i]  - EvalDiagMinY2) *
            EvalDiagFactYDiag2)));
          end;
        end;
      end;
    end;
  end;
end;

procedure TBackPropEvalDiagForm.EvalDiagPaintBox3Paint(Sender: TObject);
var
  i: Integer;
  HelpString: string;
begin
  Invalidate;
  with EvalDiagPaintBox3.Canvas do begin
    { Background }
    Brush.Color := clWhite;
    FillRect(Rect(0, 0, EvalDiagPaintBox3.Width, EvalDiagPaintBox3.Height));
    { X-axis and arrow }
    Pen.Width := 1;
    Pen.Style := psSolid;
    Pen.Color := clBlack;
    MoveTo(5, (EvalDiagPaintBox3.Height - 30));
    LineTo((EvalDiagPaintBox3.Width - 10), (EvalDiagPaintBox3.Height - 30));
    MoveTo((EvalDiagPaintBox3.Width - 10), (EvalDiagPaintBox3.Height - 30));
    LineTo((EvalDiagPaintBox3.Width - 20), (EvalDiagPaintBox3.Height - 33));
    MoveTo((EvalDiagPaintBox3.Width - 10), (EvalDiagPaintBox3.Height - 30));
    LineTo((EvalDiagPaintBox3.Width - 20), (EvalDiagPaintBox3.Height - 27));
    { Y-axis and arrow }
    MoveTo(10, (EvalDiagPaintBox3.Height - 25)); LineTo(10, 30);
    MoveTo(10, 30); LineTo(7, 40);
    MoveTo(10, 30); LineTo(13, 40);
    { Grid }
    Pen.Style := psDot;
    for i := 1 to 10 do begin
      MoveTo(10 + (i * Round((EvalDiagPaintBox3.Width - 20) / 10)),
      (EvalDiagPaintBox3.Height - 30));
      LineTo(10 + (i * Round((EvalDiagPaintBox3.Width - 20) / 10)), 30);
    end;
    { Display values }
    TextOut((EvalDiagPaintBox3.Width - 150),
    (EvalDiagPaintBox3.Height - 25), 'Lernschritte: ' +
    IntToStr(Round(EvalDiagMaxX3)));
    if (EvalDiagMinY3 > 10)
    then Str(EvalDiagMinY3 : 10 : 2, HelpString)
    else Str(EvalDiagMinY3 : 1 : 8, HelpString);
    TextOut(5, (EvalDiagPaintBox3.Height - 25), 'Minimum: ' + HelpString);
    if (EvalDiagMaxY3 > 10)
    then Str(EvalDiagMaxY3 : 10 : 2, HelpString)
    else Str(EvalDiagMaxY3 : 1 : 8, HelpString);
    TextOut(5, 5, 'Maximum: ' + HelpString);
    { Draw data }
    if (EvalDiagDataList3 <> nil) then begin
      if (EvalDiagDataList3.Count > 0) then begin
        Pen.Style := psSolid;
        Pen.Color := clRed;
        MoveTo(10, ((EvalDiagPaintBox3.Height - 30) -
        Round((EvalDiagDataList3[0] - EvalDiagMinY3) * EvalDiagFactYDiag3)));
        if EvalDiagDataList3.Count > 1 then begin
          for i := 1 to (EvalDiagDataList3.Count - 1) do begin
            LineTo((10 + Round(i * EvalDiagFactXDiag3)),
            ((EvalDiagPaintBox3.Height - 30) -
            Round((EvalDiagDataList3[i] - EvalDiagMinY3) *
            EvalDiagFactYDiag3)));
          end;
        end;
      end;
    end;
  end;
end;

procedure TBackPropEvalDiagForm.EvalDiagPaintBox4Paint(Sender: TObject);
var
  i: Integer;
  HelpString: string;
begin
  Invalidate;
  with EvalDiagPaintBox4.Canvas do begin
    { Background }
    Brush.Color := clWhite;
    FillRect(Rect(0, 0, EvalDiagPaintBox4.Width, EvalDiagPaintBox4.Height));
    { X-axis and arrow }
    Pen.Width := 1;
    Pen.Style := psSolid;
    Pen.Color := clBlack;
    MoveTo(5, (EvalDiagPaintBox4.Height - 30));
    LineTo((EvalDiagPaintBox4.Width - 10), (EvalDiagPaintBox4.Height - 30));
    MoveTo((EvalDiagPaintBox4.Width - 10), (EvalDiagPaintBox4.Height - 30));
    LineTo((EvalDiagPaintBox4.Width - 20), (EvalDiagPaintBox4.Height - 33));
    MoveTo((EvalDiagPaintBox4.Width - 10), (EvalDiagPaintBox4.Height - 30));
    LineTo((EvalDiagPaintBox4.Width - 20), (EvalDiagPaintBox4.Height - 27));
    { Y-axis and arrow }
    MoveTo(10, (EvalDiagPaintBox4.Height - 25)); LineTo(10, 30);
    MoveTo(10, 30); LineTo(7, 40);
    MoveTo(10, 30); LineTo(13, 40);
    { Grid }
    Pen.Style := psDot;
    for i := 1 to 10 do begin
      MoveTo(10 + (i * Round((EvalDiagPaintBox4.Width - 20) / 10)),
      (EvalDiagPaintBox4.Height - 30));
      LineTo(10 + (i * Round((EvalDiagPaintBox4.Width - 20) / 10)), 30);
    end;
    { Display values }
    TextOut((EvalDiagPaintBox4.Width - 150),
    (EvalDiagPaintBox4.Height - 25), 'Lernschritte: ' +
    IntToStr(Round(EvalDiagMaxX4)));
    if (EvalDiagMinY4 > 10)
    then Str(EvalDiagMinY4 : 10 : 2, HelpString)
    else Str(EvalDiagMinY4 : 1 : 8, HelpString);
    TextOut(5, (EvalDiagPaintBox4.Height - 25), 'Minimum: ' + HelpString);
    if (EvalDiagMaxY4 > 10)
    then Str(EvalDiagMaxY4 : 10 : 2, HelpString)
    else Str(EvalDiagMaxY4 : 1 : 8, HelpString);
    TextOut(5, 5, 'Maximum: ' + HelpString);
    { Draw data }
    if (EvalDiagDataList4 <> nil) then begin
      if (EvalDiagDataList4.Count > 0) then begin
        Pen.Style := psSolid;
        Pen.Color := clRed;
        MoveTo(10, ((EvalDiagPaintBox4.Height - 30) -
        Round((EvalDiagDataList4[0] - EvalDiagMinY4) * EvalDiagFactYDiag4)));
        if EvalDiagDataList4.Count > 1 then begin
          for i := 1 to (EvalDiagDataList4.Count - 1) do begin
            LineTo((10 + Round(i * EvalDiagFactXDiag4)),
            ((EvalDiagPaintBox4.Height - 30) -
            Round((EvalDiagDataList4[i] - EvalDiagMinY4) *
            EvalDiagFactYDiag4)));
          end;
        end;
      end;
    end;
  end;
end;

procedure TBackPropEvalDiagForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  BackPropEvalDiagForm.Hide;
  CanClose := False;
end;

procedure TBackPropEvalDiagForm.FormCreate(Sender: TObject);
var
  { List for initializing the DiagramForm }
  EvalDiagDataListInit: TRealArray;
begin
  EvalDiagDataListInit := TRealArray.Create(0);
  { Paint empty diagrams }
  EvalDiagSetDataList1(EvalDiagDataListInit);
  EvalDiagSetDataList2(EvalDiagDataListInit);
  EvalDiagSetDataList3(EvalDiagDataListInit);
  EvalDiagSetDataList4(EvalDiagDataListInit);
  { Free all local lists }
  EvalDiagDataListInit.Free;
end;

procedure TBackPropEvalDiagForm.FormResize(Sender: TObject);
var
  i: Integer;
  { Parameters for resizing the DiagramForm }
  EvalDiagDataList1Orig: TRealArray;
  EvalDiagDataList2Orig: TRealArray;
  EvalDiagDataList3Orig: TRealArray;
  EvalDiagDataList4Orig: TRealArray;
begin
  { Get new size-parameters of DiagramForm }
  EvalDiagPanel1.Height := Round(EvalDiagPanelCurves.Height / 4);
  EvalDiagPanel2.Height := Round(EvalDiagPanelCurves.Height / 4);
  EvalDiagPanel3.Height := Round(EvalDiagPanelCurves.Height / 4);
  { Store original lists and calculate parameters new }
  EvalDiagDataList1Orig := TRealArray.Create(0);
  if (EvalDiagDataList1.Count > 0) then begin
    for i := 0 to (EvalDiagDataList1.Count - 1) do begin
      EvalDiagDataList1Orig.Add(EvalDiagDataList1[i]);
    end;
  end;
  EvalDiagDataList2Orig := TRealArray.Create(0);
  if (EvalDiagDataList2.Count > 0) then begin
    for i := 0 to (EvalDiagDataList2.Count - 1) do begin
      EvalDiagDataList2Orig.Add(EvalDiagDataList2[i]);
    end;
  end;
  EvalDiagDataList3Orig := TRealArray.Create(0);
  if (EvalDiagDataList3.Count > 0) then begin
    for i := 0 to (EvalDiagDataList3.Count - 1) do begin
      EvalDiagDataList3Orig.Add(EvalDiagDataList3[i]);
    end;
  end;
  EvalDiagDataList4Orig := TRealArray.Create(0);
  if (EvalDiagDataList4.Count > 0) then begin
    for i := 0 to (EvalDiagDataList4.Count - 1) do begin
      EvalDiagDataList4Orig.Add(EvalDiagDataList4[i]);
    end;
  end;
  { Paint diagrams new }
  EvalDiagSetDataList1(EvalDiagDataList1Orig);
  EvalDiagSetDataList2(EvalDiagDataList2Orig);
  EvalDiagSetDataList3(EvalDiagDataList3Orig);
  EvalDiagSetDataList4(EvalDiagDataList4Orig);
  { Free all local lists }
  EvalDiagDataList1Orig.Free;
  EvalDiagDataList2Orig.Free;
  EvalDiagDataList3Orig.Free;
  EvalDiagDataList4Orig.Free;
end;

{ Public-Deklarationen of TBackPropEvalDiagForm }

procedure TBackPropEvalDiagForm.EvalDiagSetDataList1
  (AnEvalDataList: TRealArray);
var
  i: Integer;
  RangeX, RangeY: Double;
begin
  EvalDiagDataList1.Free;
  EvalDiagDataList1 := TRealArray.Create(0);
  if (AnEvalDataList.Count > 0) then begin
    { Transmitt overgiven list to local list }
    for i := 0 to (AnEvalDataList.Count - 1) do begin
      EvalDiagDataList1.Add(AnEvalDataList[i]);
    end;
    { Get minimum and maximum of curve }
    EvalDiagMinX1 := 1;
    EvalDiagMaxX1 := EvalDiagDataList1.Count;
    EvalDiagMinY1 := EvalDiagDataList1[0];
    EvalDiagMaxY1 := EvalDiagDataList1[0];
    for i := 0 to (EvalDiagDataList1.Count - 1) do begin
      if (EvalDiagDataList1[i] < EvalDiagMinY1) then begin
        EvalDiagMinY1 := EvalDiagDataList1[i];
      end;
      if (EvalDiagDataList1[i] > EvalDiagMaxY1) then begin
        EvalDiagMaxY1 := EvalDiagDataList1[i];
      end;
    end;
    { Calculate ranges for x- and y-axis }
    RangeX := (EvalDiagMaxX1 - EvalDiagMinX1);
    if (RangeX <> 0.0) then begin
      EvalDiagFactXDiag1 := ((EvalDiagPaintBox1.Width - 30) / RangeX);
    end
    else begin
      EvalDiagFactXDiag1 := 0;
    end;
    RangeY := (EvalDiagMaxY1 - EvalDiagMinY1);
    if (RangeY <> 0.0) then begin
      EvalDiagFactYDiag1 := ((EvalDiagPaintBox1.Height - 60) / RangeY);
    end
    else begin
      EvalDiagFactYDiag1 := 0;
    end;
  end
  else begin
    { Set parameters to zero }
    EvalDiagFactXDiag1 := 0;
    EvalDiagFactYDiag1 := 0;
    EvalDiagMaxX1 := 0;
    EvalDiagMinX1 := 0;
    EvalDiagMaxY1 := 0;
    EvalDiagMinY1 := 0;
  end;
  { Call procedure to paint diagram }
  EvalDiagPaintBox1Paint(Self);
end;

procedure TBackPropEvalDiagForm.EvalDiagSetDataList2
  (AnEvalDataList: TRealArray);
var
  i: Integer;
  RangeX, RangeY: Double;
begin
  EvalDiagDataList2.Free;
  EvalDiagDataList2 := TRealArray.Create(0);
  if (AnEvalDataList.Count > 0) then begin
    { Transmitt overgiven list to local list }
    for i := 0 to (AnEvalDataList.Count - 1) do begin
      EvalDiagDataList2.Add(AnEvalDataList[i]);
    end;
    { Get minimum and maximum of curve }
    EvalDiagMinX2 := 1;
    EvalDiagMaxX2 := EvalDiagDataList2.Count;
    EvalDiagMinY2 := EvalDiagDataList2[0];
    EvalDiagMaxY2 := EvalDiagDataList2[0];
    for i := 0 to (EvalDiagDataList2.Count - 1) do begin
      if (EvalDiagDataList2[i] < EvalDiagMinY2) then begin
        EvalDiagMinY2 := EvalDiagDataList2[i];
      end;
      if (EvalDiagDataList2[i] > EvalDiagMaxY2) then begin
        EvalDiagMaxY2 := EvalDiagDataList2[i];
      end;
    end;
    { Calculate ranges for x- and y-axis }
    RangeX := (EvalDiagMaxX2 - EvalDiagMinX2);
    if (RangeX <> 0.0) then begin
      EvalDiagFactXDiag2 := ((EvalDiagPaintBox2.Width - 30) / RangeX);
    end
    else begin
      EvalDiagFactXDiag2 := 0;
    end;
    Rangey := (EvalDiagMaxY2 - EvalDiagMinY2);
    if (RangeY <> 0.0) then begin
      EvalDiagFactYDiag2 := ((EvalDiagPaintBox2.Height - 60) / RangeY);
    end
    else begin
      EvalDiagFactYDiag2 := 0;
    end;
  end
  else begin
    { Set parameters to zero }
    EvalDiagFactXDiag2 := 0;
    EvalDiagFactYDiag2 := 0;
    EvalDiagMaxX2 := 0;
    EvalDiagMinX2 := 0;
    EvalDiagMaxY2 := 0;
    EvalDiagMinY2 := 0;
  end;
  { Call procedure to paint diagram }
  EvalDiagPaintBox2Paint(Self);
end;

procedure TBackPropEvalDiagForm.EvalDiagSetDataList3
  (AnEvalDataList: TRealArray);
var
  i: Integer;
  RangeX, RangeY: Double;
begin
  EvalDiagDataList3.Free;
  EvalDiagDataList3 := TRealArray.Create(0);
  if (AnEvalDataList.Count > 0) then begin
    { Transmitt overgiven list to local list }
    for i := 0 to (AnEvalDataList.Count - 1) do begin
      EvalDiagDataList3.Add(AnEvalDataList[i]);
    end;
    { Get minimum and maximum of curve }
    EvalDiagMinX3 := 1;
    EvalDiagMaxX3 := EvalDiagDataList3.Count;
    EvalDiagMinY3 := EvalDiagDataList3[0];
    EvalDiagMaxY3 := EvalDiagDataList3[0];
    for i := 0 to (EvalDiagDataList3.Count - 1) do begin
      if (EvalDiagDataList3[i] < EvalDiagMinY3) then begin
        EvalDiagMinY3 := EvalDiagDataList3[i];
      end;
      if (EvalDiagDataList3[i] > EvalDiagMaxY3) then begin
        EvalDiagMaxY3 := EvalDiagDataList3[i];
      end;
    end;
    { Calculate ranges for x- and y-axis }
    RangeX := (EvalDiagMaxX3 - EvalDiagMinX3);
    if (RangeX <> 0.0) then begin
      EvalDiagFactXDiag3 := ((EvalDiagPaintBox3.Width - 30) / RangeX);
    end
    else begin
      EvalDiagFactXDiag3 := 0;
    end;
    Rangey := (EvalDiagMaxY3 - EvalDiagMinY3);
    if (RangeY <> 0.0) then begin
      EvalDiagFactYDiag3 := ((EvalDiagPaintBox3.Height - 60) / RangeY);
    end
    else begin
      EvalDiagFactYDiag3 := 0;
    end;
  end
  else begin
    { Set parameters to zero }
    EvalDiagFactXDiag3 := 0;
    EvalDiagFactYDiag3 := 0;
    EvalDiagMaxX3 := 0;
    EvalDiagMinX3 := 0;
    EvalDiagMaxY3 := 0;
    EvalDiagMinY3 := 0;
  end;
  { Call procedure to paint diagram }
  EvalDiagPaintBox3Paint(Self);
end;

procedure TBackPropEvalDiagForm.EvalDiagSetDataList4
  (AnEvalDataList: TRealArray);
var
  i: Integer;
  RangeX, RangeY: Double;
begin
  EvalDiagDataList4.Free;
  EvalDiagDataList4 := TRealArray.Create(0);
  if (AnEvalDataList.Count > 0) then begin
    { Transmitt overgiven list to local list }
    for i := 0 to (AnEvalDataList.Count - 1) do begin
      EvalDiagDataList4.Add(AnEvalDataList[i]);
    end;
    { Get minimum and maximum of curve }
    EvalDiagMinX4 := 1;
    EvalDiagMaxX4 := EvalDiagDataList4.Count;
    EvalDiagMinY4 := EvalDiagDataList4[0];
    EvalDiagMaxY4 := EvalDiagDataList4[0];
    for i := 0 to (EvalDiagDataList4.Count - 1) do begin
      if (EvalDiagDataList4[i] < EvalDiagMinY4) then begin
        EvalDiagMinY4 := EvalDiagDataList4[i];
      end;
      if (EvalDiagDataList4[i] > EvalDiagMaxY4) then begin
        EvalDiagMaxY4 := EvalDiagDataList4[i];
      end;
    end;
    { Calculate ranges for x- and y-axis }
    RangeX := (EvalDiagMaxX4 - EvalDiagMinX4);
    if (RangeX <> 0.0) then begin
      EvalDiagFactXDiag4 := ((EvalDiagPaintBox4.Width - 30) / RangeX);
    end
    else begin
      EvalDiagFactXDiag4 := 0;
    end;
    Rangey := (EvalDiagMaxY4 - EvalDiagMinY4);
    if (RangeY <> 0.0) then begin
      EvalDiagFactYDiag4 := ((EvalDiagPaintBox4.Height - 60) / RangeY);
    end
    else begin
      EvalDiagFactYDiag4 := 0;
    end;
  end
  else begin
    { Set parameters to zero }
    EvalDiagFactXDiag4 := 0;
    EvalDiagFactYDiag4 := 0;
    EvalDiagMaxX4 := 0;
    EvalDiagMinX4 := 0;
    EvalDiagMaxY4 := 0;
    EvalDiagMinY4 := 0;
  end;
  { Call procedure to paint diagram }
  EvalDiagPaintBox4Paint(Self);
end;

end.
