
{***************************************************************************}
{                                                                           }
{     Form: 'BackPropEvalProcCorrForm.dfm'                                  }
{     Unit: 'BackPropEvalProcCorrFormFile.pas'                              }
{     ( containing data processing auto-/cross-correlation )                }
{                                                                           }
{     - belonging to:                                                       }
{       Form:    'BackPropForm.dfm'                                         }
{       Unit:    'BackPropFormFile.pas'                                     }
{       Project: 'BackPropagation.dpr'                                      }
{       DLL:     'BackPropagation.dll'                                      }
{       Program: 'ResNeuronum.exe'                                          }
{       ( simulating Neural Networks )                                      }
{                                                                           }
{     - written in Borland Delphi 2.0                                       }
{                                                                           }
{     Copyright (c) 1996-97 TU Ilmenau/ Germany                             }
{                                                                           }
{     Written by:                                                           }
{       Christian Heller                                                    }
{       Grenzgraben 04                                                      }
{       D-98714 Sttzerbach                                                 }
{       Thringen                                                           }
{       Deutschland/ Germany/ Allemagne                                     }
{       Tel.:   +49/ (0)36784/ 50471 (Euro-ISDN)                            }
{       or Tel: +49/ (0)36784/ 50690                                        }
{       Fax G3: +49/ (0)36784/ 50992 (Euro-ISDN)                            }
{       e-mail: Christian.Heller@rz.tu-ilmenau.de                           }
{       www:    http://www.rz.tu-ilmenau.de/~ai008/christian/enmain.htm     }
{       www:    http://www.rz.tu-ilmenau.de/~ai008/resneuronum/enmain.htm   }
{                                                                           }
{     ( all variables & methods in alphabetical order                       }
{     or as appearing in the unit header, respectively )                    }
{                                                                           }
{***************************************************************************}

unit BackPropEvalProcCorrFormFile;

interface

uses
  Buttons,
  Classes,
  Controls,
  Dialogs,
  Forms,
  Graphics,
  Messages,
  Spin,
  StdCtrls,
  SysUtils,
  Windows, ExtCtrls;

type
  TBackPropEvalProcCorrForm = class(TForm)
    EvalProcCorrBitBtnCancel: TBitBtn;
    EvalProcCorrBitBtnOk: TBitBtn;
    EvalProcCorrComboBoxWith: TComboBox;
    EvalProcCorrLabelDepth: TLabel;
    EvalProcCorrLabelWith: TLabel;
    EvalProcCorrPanel: TPanel;
    EvalProcCorrSpinEditDepth: TSpinEdit;
    procedure EvalProcCorrSpinEditDepthChange(Sender: TObject);
  private
  public
  end;

var
  BackPropEvalProcCorrForm: TBackPropEvalProcCorrForm;

implementation

{$R *.DFM}

procedure TBackPropEvalProcCorrForm.EvalProcCorrSpinEditDepthChange(Sender: TObject);
begin
  with EvalProcCorrSpinEditDepth do try
    { Check the given value for conflict with list length }
    if ((Value < 1) or (Value > MaxValue)) then begin
      MessageBeep(0);
      MessageDlg('Wert fr Korrelationstiefe prfen ' + #13#10#10 +
        '(mind. 1, hchstens max. ListenLnge = Lernschrittanzahl)!', mtError, [mbOk], 0);
      Value := 1;
      SetFocus;
    end;
  except
    on EConvertError do begin
      MessageBeep(0);
      MessageDlg('Wert fr Korrelationstiefe muss Integer sein!', mtError, [mbOk], 0);
      Value := 1;
      SetFocus;
    end;
  end;
end;

end.
