
{***************************************************************************}
{                                                                           }
{     Form: 'BackPropEvalProcFiltForm.dfm'                                  }
{     Unit: 'BackPropEvalProcFiltFormFile.pas'                              }
{     ( containing data processing for high-/low-pass-filter )              }
{                                                                           }
{     - belonging to:                                                       }
{       Form:    'BackPropForm.dfm'                                         }
{       Unit:    'BackPropFormFile.pas'                                     }
{       Project: 'BackPropagation.dpr'                                      }
{       DLL:     'BackPropagation.dll'                                      }
{       Program: 'ResNeuronum.exe'                                          }
{       ( simulating Neural Networks )                                      }
{                                                                           }
{     - written in Borland Delphi 2.0                                       }
{                                                                           }
{     Copyright (c) 1996-97 TU Ilmenau/ Germany                             }
{                                                                           }
{     Written by:                                                           }
{       Christian Heller                                                    }
{       Grenzgraben 04                                                      }
{       D-98714 Sttzerbach                                                 }
{       Thringen                                                           }
{       Deutschland/ Germany/ Allemagne                                     }
{       Tel.:   +49/ (0)36784/ 50471 (Euro-ISDN)                            }
{       or Tel: +49/ (0)36784/ 50690                                        }
{       Fax G3: +49/ (0)36784/ 50992 (Euro-ISDN)                            }
{       e-mail: Christian.Heller@rz.tu-ilmenau.de                           }
{       www:    http://www.rz.tu-ilmenau.de/~ai008/christian/enmain.htm     }
{       www:    http://www.rz.tu-ilmenau.de/~ai008/resneuronum/enmain.htm   }
{                                                                           }
{     ( all variables & methods in alphabetical order                       }
{     or as appearing in the unit header, respectively )                    }
{                                                                           }
{***************************************************************************}

unit BackPropEvalProcFiltFormFile;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ExtCtrls;

type
  TBackPropEvalProcFiltForm = class(TForm)
    EvalProcFiltBitBtnCancel: TBitBtn;
    EvalProcFiltBitBtnOk: TBitBtn;
    EvalProcFiltGroupBox: TGroupBox;
    EvalProcFiltSpeedButtonHighPass: TSpeedButton;
    EvalProcFiltSpeedButtonLowPass: TSpeedButton;
    EvalProcFiltGroupBoxConst: TGroupBox;
    EvalProcFiltLabelMin: TLabel;
    EvalProcFiltLabelMax: TLabel;
    EvalProcFiltEdit: TEdit;
    procedure EvalProcFiltEditChange(Sender: TObject);
    procedure EvalProcFiltSpeedButtonPassClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  BackPropEvalProcFiltForm: TBackPropEvalProcFiltForm;

implementation

{$R *.DFM}

procedure TBackPropEvalProcFiltForm.EvalProcFiltSpeedButtonPassClick(Sender: TObject);
begin
  if (EvalProcFiltSpeedButtonHighPass.Down = True) then begin
    EvalProcFiltLabelMin.Caption := '-1 <';
    EvalProcFiltLabelMax.Caption := '< 0';
    EvalProcFiltEdit.Text := '-0,5';
  end
  else begin
    EvalProcFiltLabelMin.Caption := '0 <';
    EvalProcFiltLabelMax.Caption := '< 1';
    EvalProcFiltEdit.Text := '0,5';
  end;
end;

procedure TBackPropEvalProcFiltForm.EvalProcFiltEditChange(Sender: TObject);
begin
  if (EvalProcFiltSpeedButtonHighPass.Down = True) then begin
    { Check if string is value }
    with EvalProcFiltEdit do try
      { Check if value is placed in defined range }
      if ((StrToFloat(Text) < -1) or (StrToFloat(Text) > 0)) then begin
        MessageBeep(0);
        MessageDlg('Wert muss im angegebenen Bereich liegen!', mtError, [mbOk], 0);
        Text := '-0,5';
        SetFocus;
      end;
    except
      on EConvertError do begin
        MessageBeep(0);
        MessageDlg('Wert fr FilterKonstante prfen (Fliesskommawert)!', mtError, [mbOk], 0);
        Text := '-0,5';
        SetFocus;
      end;
    end;
  end
  else begin
    { Check if string is value }
    with EvalProcFiltEdit do try
      { Check if value is placed in defined range }
      if ((StrToFloat(Text) < 0) or (StrToFloat(Text) > 1)) then begin
        MessageBeep(0);
        MessageDlg('Wert muss im angegebenen Bereich liegen!', mtError, [mbOk], 0);
        Text := '0,5';
        SetFocus;
      end;
    except
      on EConvertError do begin
        MessageBeep(0);
        MessageDlg('Wert fr FilterKonstante prfen (Fliesskommawert)!', mtError, [mbOk], 0);
        Text := '0,5';
        SetFocus;
      end;
    end;
  end;
end;

procedure TBackPropEvalProcFiltForm.FormCreate(Sender: TObject);
begin
  EvalProcFiltSpeedButtonHighPass.Down := True;
  EvalProcFiltLabelMin.Caption := '-1 <';
  EvalProcFiltLabelMax.Caption := '< 0';
  EvalProcFiltEdit.Text := '-0,5';
end;

end.
