
{***************************************************************************}
{                                                                           }
{     Form: 'ResNeuroSettingsForm.dfm'                                      }
{     Unit: 'ResNeuroSettingsFormFile.pas'                                  }
{     ( various settings for program )                                      }
{                                                                           }
{     - belonging to:                                                       }
{       Form:    'ResNeuroBasicForm.dfm'                                    }
{       Unit:    'ResNeuroBasicForm.pas'                                    }
{       Project: 'ResNeuronum.dpr'                                          }
{       Program: 'ResNeuronum.exe'                                          }
{       ( simulating Neural Networks )                                      }
{                                                                           }
{     - written in Borland Delphi 2.0                                       }
{                                                                           }
{     Copyright (c) 1996-97 TU Ilmenau/ Germany                             }
{                                                                           }
{     Written by:                                                           }
{       Christian Heller                                                    }
{       Grenzgraben 04                                                      }
{       D-98714 Sttzerbach                                                 }
{       Thringen                                                           }
{       Deutschland/ Germany/ Allemagne                                     }
{       Tel.:   +49/ (0)36784/ 50471 (Euro-ISDN)                            }
{       or Tel: +49/ (0)36784/ 50690                                        }
{       Fax G3: +49/ (0)36784/ 50992 (Euro-ISDN)                            }
{       e-mail: Christian.Heller@rz.tu-ilmenau.de                           }
{       www:    http://www.rz.tu-ilmenau.de/~ai008/christian/enmain.htm     }
{       www:    http://www.rz.tu-ilmenau.de/~ai008/resneuronum/enmain.htm   }
{                                                                           }
{     ( all variables & methods in alphabetical order                       }
{     or as appearing in the unit header, respectively )                    }
{                                                                           }
{***************************************************************************}

unit ResNeuroSettingsFormFile;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TResNeuroSettingsForm = class(TForm)
    BitBtnOk: TBitBtn;
    CheckBoxBeenFunHymn: TCheckBox;
    CheckBoxExitApplHymn: TCheckBox;
    CheckBoxLogo: TCheckBox;
    CheckBoxLogoHymn: TCheckBox;
    GroupBoxLogo: TGroupBox;
    GroupBoxSound: TGroupBox;
    procedure BitBtnOkClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  ResNeuroSettingsForm: TResNeuroSettingsForm;

implementation

uses
  { Self written units that are essential }
  ResNeuroBasicFormFile;

{$R *.DFM}

procedure TResNeuroSettingsForm.BitBtnOkClick(Sender: TObject);
begin
  Close;
end;

procedure TResNeuroSettingsForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if (CheckBoxLogo.Checked) = True then ResNeuroBasicForm.SettLogo := True
  else ResNeuroBasicForm.SettLogo := False;
  if (CheckBoxLogoHymn.Checked = True) then ResNeuroBasicForm.SettLogoHymn := True
  else ResNeuroBasicForm.SettLogoHymn := False;
  if (CheckBoxExitApplHymn.Checked = True) then ResNeuroBasicForm.SettExitApplHymn := True
  else ResNeuroBasicForm.SettExitApplHymn := False;
  if (CheckBoxBeenFunHymn.Checked = True) then ResNeuroBasicForm.SettBeenFunHymn := True
  else ResNeuroBasicForm.SettBeenFunHymn := False;
end;

procedure TResNeuroSettingsForm.FormCreate(Sender: TObject);
begin
  if (ResNeuroBasicForm.SettLogo = True) then CheckBoxLogo.Checked := True
  else CheckBoxLogo.Checked := False;
  if (ResNeuroBasicForm.SettLogoHymn = True) then CheckBoxLogoHymn.Checked := True
  else CheckBoxLogoHymn.Checked := False;
  if (ResNeuroBasicForm.SettExitApplHymn = True) then CheckBoxExitApplHymn.Checked := True
  else CheckBoxExitApplHymn.Checked := False;
  if (ResNeuroBasicForm.SettBeenFunHymn = True) then CheckBoxBeenFunHymn.Checked := True
  else CheckBoxBeenFunHymn.Checked := False;
end;

end.
